<?php
/* ###################################################################

Contentpapst wurde von der sandoba.de medien agentur (www.sandoba.de) aus Berlin entworfen und unterliegt dem Urheberrecht. Jedwede nderung des Codes auerhalb der Lizenzrechte ist nicht erlaubt. Anfragen bitte an "contact@sandoba.de".

Website: www.sandoba.de
 sandoba.de medien agentur, 2002-2004

#################################################################### */

class contentpapst_gui_statistic extends contentpapst_statistic {

	var $module_configuration;
	var $module_language;

	var $statistic_max = "425";
	var $statistic_max_2 = "395";

	/*
		class contentpapst_gui_statistic::contentpapst_gui_statistic
		Konstruktur, dient der Initialisierung der Klasse und einiger Variablen.
	*/

	function contentpapst_gui_statistic() {

		GLOBAL $file, $lang, $mode;

		$this->module_language = module_language($file) + $lang;

		$this->module_configuration["basics"] = array(
													"title"=>$this->module_language["main"]["stats"],
													"description"=>$this->module_language["main"]["statsdesc"]
												);

		$this->module_configuration["navigation"] = array(
														"main"=>array($this->module_language["main"]["overview"], "2", array())
												   );

		$this->module_configuration["functions"] = array(
														"main"=>array("do_main", array()),
														"restart"=>array("do_restart", array()),
														"referer"=>array("do_referer", array()),
														"page_2"=>array("do_page_2", array()),
														"page_3"=>array("do_page_3", array()),
														"page_4"=>array("do_page_4", array()),
														"search_words"=>array("do_search_words", array()),
														"set_options"=>array("do_set_options", array("form")),
														"graphic"=>array("do_graphic", array())
													 );

		$this->module_configuration["rights"] = array(
														"all"=>array("options")
													 );

	}

	/*
		class contentpapst_gui_statistic::install
		SQL- und Dateianweisungen zur Installation des Modules.
	*/

	function install() { }

	/*
		class contentpapst_gui_statistic::uninstall
		SQL- und Dateianweisungen zur Deinstallation des Modules.
	*/

	function uninstall() { }

	##################################################################

	/*
		class contentpapst_gui_statistic::do_main
	*/

	function do_main() {

		include("config.php");
		include_once("functions/cp.string.php");
		include_once("functions/cp.date.php");
		include("themes/backend/style.php");

		GLOBAL $sql, $file, $PHP_SELF;

		$totalpages = 0;
		$numdays = 0;

		$result = db_select("SELECT number FROM ".$sql."_stats_power");
		$totalpages = db_num_rows($result);

		$result = db_select("SELECT UNIX_TIMESTAMP(date) AS date_unix, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by DATE_FORMAT(date,'%d%m%y') ORDER by count DESC LIMIT 0,1");
		while ($row = db_fetch_array($result,"assoc")) {
			$best_day = date("d.m.Y",$row["date_unix"])." (".$row["count"].")";
		}

		$result = db_select("SELECT UNIX_TIMESTAMP(date) AS date_unix FROM ".$sql."_stats_power ORDER by date ASC LIMIT 0,1");
		while ($row = db_fetch_array($result,"assoc")) {
			$numdays = ceil((time()-$row["date_unix"])/86400);
		}

		$averageday = @sprintf("%01.02f",($totalpages/$numdays));
		$averagehour = @sprintf("%01.02f",($averageday/24));

		$result = db_select("SELECT number FROM ".$sql."_stats_power WHERE browser LIKE '%msie%' OR browser LIKE '%netscape%' OR browser LIKE '%mozilla%' OR browser LIKE '%phoenix%' OR browser LIKE '%firebird%' OR browser LIKE '%konquerer%' OR browser LIKE '%safari%' OR browser LIKE '%opera%'");
		$num_javasupport = db_num_rows($result);

		if ($totalpages) {
			$javascript_support = ($num_javasupport*100)/$totalpages;
		} else {
			$javascript_support = "0";
		}

		$javascript_support = @sprintf("%01.02f",$javascript_support);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\"><tr><td width=\"50%\" valign=\"top\" align=\"left\">";

		tabletop($this->module_language["0026"]);

		echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"2\" width=\"100%\">";
		echo "<tr bgcolor=\"#FFFFFF\"><td width=\"150\"><strong>".$this->module_language["0027"].":</strong></td><td>".$numdays." ".$this->module_language["main"]["days"]."</td></tr>";
		echo "<tr bgcolor=\"#FFFFFF\"><td width=\"150\"><strong>".$this->module_language["0028"].":</strong></td><td>".$totalpages."</td></tr>";
		echo "<tr bgcolor=\"#FFFFFF\"><td width=\"150\"><strong>".$this->module_language["0029"].":</strong></td><td>".$averageday."</td></tr>";
		echo "<tr bgcolor=\"#FFFFFF\"><td width=\"150\"><strong>".$this->module_language["0030"].":</strong></td><td>".$averagehour."</td></tr>";
		echo "<tr bgcolor=\"#FFFFFF\"><td width=\"150\"><strong>".$this->module_language["0755"].":</strong></td><td>".$javascript_support." %</td></tr>";
		echo "<tr bgcolor=\"#FFFFFF\"><td width=\"150\"><strong>".$this->module_language["0804"].":</strong></td><td>".$best_day."</td></tr>";
		echo "</table>";

		tablefooter();

		echo "</td><td width=\"5\"></td><td valign=\"top\">";

		form_start("$PHP_SELF?file=$file&mode=set_options");
		tabletop($this->module_language["main"]["options"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";
		echo "<tr><td width=\"10\">";

		if ($configuration["statistic"]["lang"]) {
			form_checkbox("form[lang]", "1", "1");
		} else {
			form_checkbox("form[lang]", "1", "0");
		}

		echo "</td><td>".$this->module_language["0036"]."</td></tr>";

		echo "<tr><td width=\"10\">";

		if ($configuration["statistic"]["referer"]) {
			form_checkbox("form[referer]", "1", "1");
		} else {
			form_checkbox("form[referer]", "1", "0");
		}

		echo "</td><td>".$this->module_language["0035"]."</td></tr>";

		echo "<tr><td width=\"10\">";

		if ($configuration["statistic"]["count"]) {
			form_checkbox("form[count]", "1", "1");
		} else {
			form_checkbox("form[count]", "1", "0");
		}

		echo "</td><td>".$this->module_language["0931"]."</td></tr>";

		echo "<tr><td width=\"10\">";
		echo "<input type=\"checkbox\" value=\"1\" name=\"disabled[restart]\" class=\"checkbox\" disabled=\"disabled\"/>";
		echo "</td><td><a href=\"$PHP_SELF?file=$file&mode=restart&clean=yes\" onclick=\"return confirm('".$this->module_language["1033"]."')\">".$this->module_language["0037"]."</a></td></tr>";

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_send();
		form_stop();

		echo "&nbsp;";

		echo "<br /></td></tr></table>";

		$result = db_select("SELECT COUNT(*) AS count FROM ".$sql."_stats_power GROUP by DATE_FORMAT(date,'%d%m%y') ORDER by count DESC LIMIT 0,1");
		while ($row = db_fetch_array($result,"assoc")) {

			echo "<br />";

			tabletop($this->module_language["main"]["days"]);
			echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

			$scale = $this->statistic_max/$row["count"];

			$result_2 = db_select("SELECT UNIX_TIMESTAMP(date) AS date_unix, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by DATE_FORMAT(date,'%d%m%y') ORDER by date DESC LIMIT 0,30");
			while ($row_2 = db_fetch_array($result_2, "assoc")) {

				$width = $row_2["count"]*$scale;
				if ($totalpages) { $pro_data = ($row_2["count"]*100)/$totalpages; }
				$pro_data = @sprintf("%01.2lf",$pro_data);

				if ($width == $this->statistic_max) {
					$graphic = "poll_3.gif";
				} else {
					$graphic = "poll.gif";
				}

				if (date("d", $row_2["date_unix"]) == 01) { $graphic = "poll_4.gif"; }

				echo "<tr><td width=\"70\">".date("d.m.Y",$row_2["date_unix"])."</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\"><strong>$pro_data %</strong> (".$row_2["count"].")</td></tr>";

			}

			echo "</table>";
			tablefooter();

			echo "<br /><img src=\"themes/$themeadmin/images/icons/color_red.gif\" border=\"0\"/> ".$this->module_language["0544"]."<br /><br />";

		}

		echo $this->module_language["0031"]."<br /><br />";

		if ($totalpages) {

			echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\"><tr>";

			if (extension_loaded("gd")) {

				echo "<td valign=\"top\">";

				tabletop($this->module_language["0819"]);
				echo "<img src=\"admin.php?file=$file&mode=graphic&clean=yes\" border=\"0\" alt=\"\"/><br /><div style=\"margin-top: 6px; font-size: 10px\">".$this->module_language["0820"]."</div>";
				tablefooter();

				echo "</td><td width=\"10\"></td>";

			}

			echo "<td valign=\"top\" width=\"56%\">";

			tabletop($this->module_language["0032"]." (<a href=\"$PHP_SELF?file=$file&mode=referer\">".$this->module_language["0756"]."</a>)");
			echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"2\" width=\"100%\"><tr><td colspan=\"2\"><strong>".$this->module_language["0033"]."</strong></td><td></td><td><strong>".$this->module_language["main"]["page"]."</strong></td></tr>";

			$color_array = array("#2DC729", "#29C77F", "#29C5C7", "#2986C7", "#2943C7", "#6829C7", "#AF29C7", "#C72999", "#C72959", "#C74699", "#E98D99", "#C78A29", "#C7B629", "#A4C729", "#DEDE72", "#91DE72", "#DE728E", "#DE728E", "#7C77DE", "#AAAA73");

			$result = db_select("SELECT referer, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by referer ORDER by count DESC LIMIT 0,10");
			while ($row = db_fetch_array($result,"assoc")) {

				if ($totalpages) { $pro_data = ($row["count"]*100)/$totalpages; }
				$pro_data = @sprintf("%01.2lf", $pro_data);

				$count++;
				$color = $color_array[$count-1];

				echo "<tr><td width=\"25\">".$row["count"]."</td><td width=\"50\">$pro_data %</td><td>";
				echo "<span style=\"background-color: $color\">&nbsp;&nbsp;&nbsp;</span></td><td>";

				if ($row["referer"]) {
					echo "<a href=\"".$row["referer"]."\" target=\"_blank\" title=\"".$row["referer"]."\">".cp_string_shorten($row["referer"],40)."</a>";
				} else {
					echo "<strong>".$this->module_language["main"]["request"]."</strong>";
				}

				echo "</td></tr>";

			}

			echo "<tr bgcolor=\"$color_white\"><td colspan=\"3\"></td></tr>";

			echo "</table>";
			tablefooter();

			echo "</td></tr></table><br />";

		}

		$browser_array = array(
							"msie"=>array("Internet Explorer","browser_ie.gif"),
							"opera"=>array("Opera","browser_opera.gif"),
							"icab"=>array("iCab","browser_icab.gif"),
							"lynx"=>array("Lynx","browser_lynx.gif"),
							"konquerer"=>array("Konquerer","browser_konquerer.gif"),
							"netscape"=>array("Netscape","browser_netscape.gif"),
							"phoenix"=>array("Phoenix","browser_phoenix.gif"),
							"safari"=>array("Safari","browser_safari.gif"),
							"hotjava"=>array("HotJava","browser_hotjava.gif"),
							"mozilla"=>array("Mozilla","browser_mozilla.gif"),
							"other"=>array("Andere","os_other.gif")
						);

		$browser_info_array = array();
		$total_count = 0;

		foreach ($browser_array AS $key => $value) {

			if ($value["2"]) {
				$exploded = explode("|",$value["2"]);
				$like_str = "browser LIKE '%".implode("%' OR browser LIKE '%",$exploded)."%'";
			} else {
				$like_str = "browser LIKE '%".$key."%'";
			}

			if ($key == "mozilla") {
				$mozilla_block_array = array("msie","opera","icab","lynx","konquerer","hotjava","safari","phoenix","netscape");
				$like_str .= " AND (browser NOT LIKE '%".implode("%' AND browser NOT LIKE '%",$mozilla_block_array)."%')";
			} elseif ($key != "opera") {
				$like_str .= " AND browser NOT LIKE '%opera%'";
			}

			$result = db_select("SELECT number FROM ".$sql."_stats_power WHERE ".$like_str);
			$num_res = db_num_rows($result);

			$browser_info_array[$key] = $num_res;
			$total_count += $num_res;
		}

		$browser_info_array["other"] = $totalpages-$total_count;

		arsort($browser_info_array);

		$browser_max_array = $browser_info_array;
		rsort($browser_max_array);

		if ($browser_max_array["0"]) {

			$scale = ($this->statistic_max_2-20)/$browser_max_array["0"];
			$sub_versions = array();

			tabletop($this->module_language["main"]["browser"]);

			echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

			foreach ($browser_info_array AS $key => $value) {

				$width = $value*$scale;
				if ($totalpages) { $pro_data = ($value*100)/$totalpages; }

				$pro_data = @sprintf("%01.2lf",$pro_data);

				if ($width == ($this->statistic_max_2-20)) {
					$graphic = "poll_3.gif";
				} else {
					$graphic = "poll.gif";
				}

				echo "<tr><td width=\"25\" height=\"18\">";

				if ($browser_array["$key"]["1"] AND file_exists("images/".$browser_array["$key"]["1"])) {
					echo "<img src=\"images/".$browser_array["$key"]["1"]."\" border=\"0\" alt=\"".$browser_array["$key"]["0"]."\"/> ";
				}

				echo "</td><td width=\"120\">".$browser_array["$key"]["0"]."</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\"><strong>$pro_data %</strong> (".$value.")</td></tr>";

				if ($key == "msie") {

					$sub_versions = array(
													"MSIE 6.0"=>array("Internet Explorer 6.0"),
													"MSIE 5.5"=>array("Internet Explorer 5.5"),
													"MSIE 5.0"=>array("Internet Explorer 5.0"),
													"MSIE 4"=>array("Internet Explorer 4"),
													"MSIE 3"=>array("Internet Explorer 3"),
													"MSIE 2"=>array("Internet Explorer 2")
												);

				} elseif ($key == "netscape") {

					$sub_versions = array(
													"Netscape/7"=>array("Netscape 7"),
													"Netscape6"=>array("Netscape 6"),
													"Netscape 4."=>array("Netscape 4"),
													"Netscape 3."=>array("Netscape 3")
												);

				} elseif ($key == "opera") {

					$sub_versions = array(
													"Opera/7"=>array("Opera 7", "Opera/7|Opera 7"),
													"Opera/6"=>array("Opera 6", "Opera/6|Opera 6"),
													"Opera/5"=>array("Opera 5", "Opera/5|Opera 5")
												);

				} elseif ($key == "mozilla") {

					$sub_versions = array(
													"1.5"=>array("Mozilla 1.5.x", "Mozilla/5.0%; rv:1\.5)%Gecko"),
													"1.4"=>array("Mozilla 1.4.x", "Mozilla/5.0%; rv:1\.4)%Gecko"),
													"1.3"=>array("Mozilla 1.3.x", "Mozilla/5.0%; rv:1\.3)%Gecko"),
													"1.2"=>array("Mozilla 1.2.x", "Mozilla/5.0%; rv:1\.2)%Gecko"),
													"1.1"=>array("Mozilla 1.1.x", "Mozilla/5.0%; rv:1\.1)%Gecko"),
													"1.0"=>array("Mozilla 1.0.x", "Mozilla/5.0%; rv:1\.0)%Gecko"),
													"0.9"=>array("Mozilla 0.9.x", "Mozilla/5.0%; rv:0\.9)%Gecko")
												);

				} else {

					$sub_versions = array();

				}

				if (count($sub_versions) AND $value) {

					foreach ($sub_versions AS $key_sub => $value_sub) {

						if ($value_sub["1"]) {
							$exploded = explode("|",$value_sub["1"]);
							$like_str = "browser LIKE '%".implode("%' OR browser LIKE '%",$exploded)."%'";
						} else {
							$like_str = "browser LIKE '%".$key_sub."%'";
						}

						$result_sub = db_select("SELECT number FROM ".$sql."_stats_power WHERE ".$like_str);
						$num_sub = db_num_rows($result_sub);

						if ($num_sub) {

							$pro_data = ($num_sub*100)/$value;
							$pro_data = @sprintf("%01.2lf",$pro_data);

							$width = $num_sub*$scale;

							echo "<tr><td width=\"25\"><img src=\"themes/$themeadmin/images/cms_spacer.gif\" border=\"0\" width=\"19\" heigth=\"17\" alt=\"\"/></td><td width=\"120\">".$value_sub["0"]."</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_5.gif\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\">$pro_data % (".$num_sub.")</td></tr>";

						}

					}

				}

			}

			echo "</table>";
			tablefooter();
			echo "<br />";

		}

		form_moveonsite("$PHP_SELF?file=$file&mode=page_2", $this->module_language["button"]["next"],"2");

	}

	/*
		class contentpapst_gui_statistic::do_restart
	*/

	function do_restart() {

		GLOBAL $sql, $file, $PHP_SELF;

		db_delete("DELETE FROM ".$sql."_stats_power");
		db_delete("DELETE FROM ".$sql."_stats_misc WHERE title = 'search'");
		db_update("UPDATE ".$sql."_stats_misc SET hits = '0' WHERE title = 'guestbook'");

		header("Location: $PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_statistic::do_referer
	*/

	function do_referer() {

		include_once("functions/cp.string.php");
		GLOBAL $lang, $sql, $file, $PHP_SELF;

		$totalpages = 0;

		$result = db_select("SELECT number FROM ".$sql."_stats_power");
		$totalpages = db_num_rows($result);

		tabletop($this->module_language["0535"]);
		echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"2\" width=\"100%\"><tr><td colspan=\"2\"><strong>".$this->module_language["0033"]."</strong></td><td><strong>".$this->module_language["main"]["page"]."</strong></td></tr>";

		$result = db_select("SELECT referer, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by referer ORDER by count DESC LIMIT 0,100");
		while ($row = db_fetch_array($result,"assoc")) {

			if ($totalpages) { $pro_data = ($row["count"]*100)/$totalpages; }
			$pro_data = @sprintf("%01.2lf", $pro_data);

			echo "<tr><td width=\"25\">".$row["count"]."</td><td width=\"60\">$pro_data %</td><td>";

			if ($row["referer"]) {
				echo "<a href=\"".$row["referer"]."\" target=\"_blank\">".cp_string_shorten($row["referer"],80)."</a>";
			} else {
				echo "<strong>".$this->module_language["main"]["request"]."</strong>";
			}

			echo "</td></tr>";

		}

		echo "<tr bgcolor=\"$color_white\"><td colspan=\"3\"></td></tr>";

		echo "</table>";
		tablefooter();

		echo "<br />";
		form_back("1");

	}

	/*
		class contentpapst_gui_statistic::do_page_2
	*/

	function do_page_2() {

		include("config.php");
		include_once("functions/cp.string.php");
		include("themes/backend/style.php");

		GLOBAL $lang, $sql, $file, $PHP_SELF;

		$totalpages = 0;

		$result = db_select("SELECT number FROM ".$sql."_stats_power");
		$totalpages = db_num_rows($result);

		$os_array = array(
								"win"=>array("Windows", "os_windows.gif"),
								"linux"=>array("Linux", "os_linux.gif"),
								"mac"=>array("Macintosh", "os_mac.gif"),
								"freebsd"=>array("FreeBSD", "os_freebsd.gif"),
								"sunos"=>array("SunOS", "os_sunos.gif", "sunos|i86"),
								"spider"=>array("Suchmaschinen", "os_crawler.gif", "bot|spider"),
								"unix"=>array("Unix", "os_unix.gif", "unix|hp-ux|irix|X11|osf"),
								"aix"=>array("AIX", "os_aix.gif")
							);

		$os_info_array = array();
		$total_count = 0;

		foreach ($os_array AS $key => $value) {

			if ($value["2"]) {
				$exploded = explode("|", $value["2"]);
				$like_str = "browser LIKE '%".implode("%' OR browser LIKE '%", $exploded)."%'";
			} else {
				$like_str = "browser LIKE '%".$key."%'";
			}

			$result = db_select("SELECT number FROM ".$sql."_stats_power WHERE ".$like_str);
			$num_res = db_num_rows($result);
			$os_info_array[$key] = $num_res;
			$total_count += $num_res;

		}

		$os_info_array["spider"] = $totalpages-$total_count;
		arsort($os_info_array);

		$os_max_array = $os_info_array;
		rsort($os_max_array);

		if ($os_max_array["0"]) {

			tabletop($this->module_language["main"]["os"]);
			echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"1\" width=\"100%\">";

			$scale = $this->statistic_max_2/$os_max_array["0"];

			foreach ($os_info_array AS $key => $value) {

				$width = $value*$scale;
				if ($totalpages) { $pro_data = ($value*100)/$totalpages; }
				$pro_data = @sprintf("%01.2lf", $pro_data);

				if ($width == $this->statistic_max_2) {
					$graphic = "poll_3.gif";
				} else {
					$graphic = "poll.gif";
				}

				echo "<tr><td width=\"20\">";

				if ($os_array["$key"]["1"] AND file_exists("images/".$os_array["$key"]["1"])) {
					echo "<img src=\"images/".$os_array["$key"]["1"]."\" border=\"0\" alt=\"\"/> ";
				}

				echo "</td><td width=\"100\">".$os_array["$key"]["0"]."</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\"><strong>$pro_data %</strong> (".$value.")</td></tr>";

				if ($key == "win") {

					$windows_versions = array(
															"NT 5.1"=>array("Windows XP"),
															"NT 5.0"=>array("Windows 2000"),
															"NT"=>array("Windows NT"),
															"ME"=>array("Windows ME", "ME|Windows 98; Win 9x 4.90"),
															"CE"=>array("Windows CE"),
															"98"=>array("Windows 98"),
															"95"=>array("Windows 95"),
															"3.1"=>array("Windows 3.1")
														);

					foreach ($windows_versions AS $key_win => $value_win) {

						if ($value_win["1"]) {
							$exploded = explode("|", $value_win["1"]);
							$like_str = "browser LIKE '%".implode("%' OR browser LIKE '%",$exploded)."%'";
						} else {
							$like_str = "browser LIKE '%".$key_win."%'";
						}

						if ($key_win == "NT") {
							$like_str .= " AND browser NOT LIKE '%NT 5.%'";
						} elseif ($key_win == "98") {
							$like_str .= " AND browser NOT LIKE '%ME%' AND browser NOT LIKE '%Win 9x 4.90%'";
						}

						$result_win = db_select("SELECT number FROM ".$sql."_stats_power WHERE ".$like_str);
						$num_win = db_num_rows($result_win);

						if ($num_win) {

							$pro_data = ($num_win*100)/$value;
							$pro_data = @sprintf("%01.2lf", $pro_data);

							$width = $num_win*$scale;

							echo "<tr><td width=\"20\"><img src=\"themes/$themeadmin/images/cms_spacer.gif\" border=\"0\" width=\"19\" heigth=\"17\" alt=\"\"/></td><td width=\"100\">".$value_win["0"]."</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_5.gif\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\">$pro_data % (".$num_win.")</td></tr>";

						}

					}

				}

			}

			echo "</table>";
			tablefooter();

			echo "<br />";

		}

		tabletop($this->module_language["0023"]);
		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

		$lang_array = array(
									"1"=>$this->module_language["0011"],
									"2"=>$this->module_language["0012"],
									"3"=>$this->module_language["0013"],
									"4"=>$this->module_language["0014"],
									"5"=>$this->module_language["0015"],
									"6"=>$this->module_language["0016"],
									"7"=>$this->module_language["0017"],
									"8"=>$this->module_language["0018"],
									"9"=>$this->module_language["0019"],
									"10"=>$this->module_language["0020"],
									"11"=>$this->module_language["0021"],
									"12"=>$this->module_language["0022"]
								);

		$month_array = array();

		$result = db_select("SELECT UNIX_TIMESTAMP(date) AS date_unix, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by DATE_FORMAT(date,'%m') ORDER by date DESC LIMIT 0,12");
		while ($row = db_fetch_array($result,"assoc")) {
			$date_month = date("m", $row["date_unix"]);
			if (strlen($date_month) == 2) {
				$date_month = substr($date_month, 1);
			}
			$month_array[date("m",$row["date_unix"])] = $row["count"];
		}

		$scale_array = $month_array;
		rsort($scale_array);
		$scale = $this->statistic_max/array_shift($scale_array);

		foreach ($lang_array AS $key => $value) {

			if ($key < 10) {
				$keyfull = "0".$key;
			} else {
				$keyfull = $key;
			}

			$width = $month_array["$keyfull"]*$scale;
			if ($totalpages) { $pro_data = ($month_array["$keyfull"]*100)/$totalpages; }
			$pro_data = @sprintf("%01.2lf", $pro_data);

			if ($width == $this->statistic_max) {
				$graphic = "poll_3.gif";
			} else {
				$graphic = "poll.gif";
			}

			if (!$month_array["$keyfull"]) {
				$month_array["$keyfull"] = 0;
			}

			echo "<tr><td width=\"80\">".$lang_array["$key"]."</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\"><strong>$pro_data %</strong> (".$month_array["$keyfull"].")</td></tr>";

		}

		echo "</table>";
		tablefooter();

		echo "<br />";

		tabletop($this->module_language["0024"]);
		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

		$day_name_array = array(
											"Mon"=>$this->module_language["0004"],
											"Tue"=>$this->module_language["0005"],
											"Wed"=>$this->module_language["0006"],
											"Thu"=>$this->module_language["0007"],
											"Fri"=>$this->module_language["0008"],
											"Sat"=>$this->module_language["0009"],
											"Sun"=>$this->module_language["0010"]
										);

		$days_array = array();

		$result = db_select("SELECT UNIX_TIMESTAMP(date) AS date_unix, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by DATE_FORMAT(date,'%w') ORDER by date DESC LIMIT 0,7");
		while ($row = db_fetch_array($result,"assoc")) {
			$days_array[date("D", $row["date_unix"])] = $row["count"];
		}

		$scale_array = $days_array;
		rsort($scale_array);
		$scale = $this->statistic_max/array_shift($scale_array);

		foreach ($day_name_array AS $key => $value) {

			$width = $days_array["$key"]*$scale;
			if ($totalpages) { $pro_data = ($days_array["$key"]*100)/$totalpages; }
			$pro_data = @sprintf("%01.2lf", $pro_data);

			if ($width == $this->statistic_max) {
				$graphic = "poll_3.gif";
			} else {
				$graphic = "poll.gif";
			}

			if (!$days_array["$key"]) {
				$days_array["$key"] = 0;
			}

			echo "<tr><td width=\"80\">".$value."</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\"><strong>$pro_data %</strong> (".$days_array["$key"].")</td></tr>";

		}

		echo "</table>";
		tablefooter();

		echo "<br />";

		tabletop($this->module_language["0025"]);
		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

		$hours_array = array();

		$result = db_select("SELECT UNIX_TIMESTAMP(date) AS date_unix, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by DATE_FORMAT(date,'%H') ORDER by date DESC LIMIT 0,24");
		while ($row = db_fetch_array($result,"assoc")) {
			$hours_array[date("H", $row["date_unix"])] = $row["count"];
		}

		$scale_array = $hours_array;
		rsort($scale_array);
		$scale = $this->statistic_max/array_shift($scale_array);

		for ($i = 0; $i < 24; $i++) {

			if (strlen($i) == 1) {
				$i = "0".$i;
			}

			if (!$hours_array["$i"]) {
				$hours_array["$i"] = 0;
			}

			$width = round($hours_array["$i"]*$scale);
			if ($totalpages) { $pro_data = ($hours_array["$i"]*100)/$totalpages; }
			$pro_data = @sprintf("%01.2lf", $pro_data);

			if ($width == $this->statistic_max) {
				$graphic = "poll_3.gif";
			} else {
				$graphic = "poll.gif";
			}

			echo "<tr><td width=\"80\">".$i.":00 - ".$i.":59</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"$width\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\"><strong>$pro_data %</strong> (".$hours_array["$i"].")</td></tr>";

		}

		echo "</table>";
		tablefooter();

		echo "<br />";
		form_moveon("$PHP_SELF?file=$file");

		form_moveonsite("$PHP_SELF?file=$file&mode=page_3", $this->module_language["button"]["next"], "2");

	}

	/*
		class contentpapst_gui_statistic::do_page_3
	*/

	function do_page_3() {

		include("config.php");
		include_once("functions/cp.string.php");
		include("themes/backend/style.php");

		GLOBAL $lang, $sql, $file, $PHP_SELF;

		$totalpages = 0;

		$result = db_select("SELECT number FROM ".$sql."_stats_power");
		$totalpages = db_num_rows($result);

		tabletop($this->module_language["0034"]);
		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

		$result = db_select("SELECT language, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by language ORDER by count DESC LIMIT 0,1");
		$num_results = db_num_rows($result);

		if ($num_results) {

			$result = db_select("SELECT language, COUNT(*) AS count FROM ".$sql."_stats_power WHERE language != '' GROUP by language ORDER by count DESC LIMIT 0,1");
			while ($row = db_fetch_array($result, "assoc")) {
				$scale = ($this->statistic_max_2-50)/$row["count"];
			}

			$free_data = array();

			$result = db_select("SELECT language, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by language ORDER by count DESC LIMIT 0,30");
			while ($row = db_fetch_array($result, "assoc")) {

				$width = $row["count"]*$scale;

				if ($totalpages) {
					$pro_data = ($row["count"]*100)/$totalpages;
				}

				$pro_data = @sprintf("%01.2lf", $pro_data);

				if ($width == ($this->statistic_max_2-50)) {
					$graphic = "poll_3.gif";
				} else {
					$graphic = "poll.gif";
				}

				$result_2 = db_select("SELECT * FROM ".$sql."_domains WHERE short = '".$row["language"]."'");

				if (db_num_rows($result_2)) {

					while ($row_2 = db_fetch_array($result_2,"assoc")) {
						echo "<tr><td width=\"120\">".$row_2["title"]." (.".$row["language"].")</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\" width=\"110\"><strong>$pro_data %</strong> (".$row["count"].")</td></tr>";
					}

				} else {

					$free_data["pro"] += $pro_data;
					$free_data["count"] += $row["count"];

				}

			}

			if ($free_data["count"]) {

				$width = $free_data["count"]*$scale;
				$pro_data = ($free_data["count"]*100)/$totalpages;
				$pro_data = @sprintf("%01.2lf", $pro_data);

				if ($width == $this->statistic_max_2) {
					$graphic = "poll_3.gif";
				} else {
					$graphic = "poll.gif";
				}

				echo "<tr><td width=\"120\">".$this->module_language["0940"]."</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\"><strong>".$free_data["pro"]." %</strong> (".$free_data["count"].")</td></tr>";

			}

		} else {

				echo "<tr><td align=\"center\">".$this->module_language["0644"]."</td></tr>";

		}

		echo "</table>";
		tablefooter();
		echo "<br />";

		tabletop($this->module_language["0643"]);
		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

		$result = db_select("SELECT hits FROM ".$sql."_stats_misc WHERE title = 'search' AND details != 'total' ORDER by hits DESC LIMIT 0,1");
		$num_results = db_num_rows($result);

		if ($num_results) {

			$result = db_select("SELECT hits FROM ".$sql."_stats_misc WHERE title = 'search' ORDER by hits DESC LIMIT 1");
			while ($row = db_fetch_array($result, "assoc")) {
				if ($totalpages) {
					$scale = $this->statistic_max_2/$row["hits"];
				}
			}

			$count = 0;
			$num_total = 0;

			$resulta = db_select("SELECT SUM(hits) AS total_number FROM ".$sql."_stats_misc WHERE title = 'search'");
			while ($row = db_fetch_array($resulta, "assoc")) {
				$num_total = $row["total_number"];
			}

			$resulta = db_select("SELECT * FROM ".$sql."_stats_misc WHERE title = 'search' ORDER by hits DESC LIMIT 0,30");
			while ($row = db_fetch_array($resulta, "assoc")) {

				$width = $row["hits"]*$scale;

				if ($totalpages) {
					$pro_data = ($row["hits"]*100)/$num_total;
				}

				$pro_data = @sprintf("%01.2lf",$pro_data);
				$count++;

				if ($count == 1) {
					$graphic = "poll_3.gif";
				} else {
					$graphic = "poll.gif";
				}

				echo "<tr><td width=\"120\"><a href=\"index.php?file=search&category=article&q=".$row["details"]."\">".cp_string_shorten($row["details"],20)."</a></td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\" width=\"110\"><strong>$pro_data %</strong> (".$row["hits"].")</td></tr>";

			}

		} else {

			echo "<tr><td align=\"center\">".$this->module_language["0644"]."</td></tr>";

		}

		echo "</table>";

		tablefooter();
		echo "<br />";

		$spider_array = array(
										"aladin"=>array("<a href=\"http://www.aladin.de\" target=\"_blank\">Aladin</a>"),
										"googlebot"=>array("<a href=\"http://www.google.de\" target=\"_blank\">Google (Bots/Spider)</a>","googlebot|googlebot-image|backrub"),
										"lycos"=>array("<a href=\"http://www.lycos.de\" target=\"_blank\">Lycos</a>","lycos_spider"),
										"hotbot"=>array("<a href=\"http://www.inktomi.com\" target=\"_blank\">Inktomi</a>/<a href=\"http://www.hotbot.com\" target=\"_blank\">Hotbot</a>","slurp"),
										"infoseek"=>array("<a href=\"http://www.infoseek.com\" target=\"_blank\">Infoseek</a>","infoseek|giordano"),
										"excite"=>array("<a href=\"http://www.excite.com\" target=\"_blank\">Excite</a>","architextspider"),
										"euroseek"=>array("<a href=\"http://www.euroseek.com\" target=\"_blank\">Euroseek</a>","freecrawl|arachnoidea"),
										"fireball"=>array("<a href=\"http://www.fireball.de\" target=\"_blank\">Fireball</a>","fireball|heavymetal"),
										"abacho"=>array("<a href=\"http://www.abacho.de\" target=\"_blank\">Abacho</a>","abachobot"),
										"acoon"=>array("<a href=\"http://www.acoon.de\" target=\"_blank\">Acoon</a>"),
										"altavista"=>array("<a href=\"http://www.altavista.de\" target=\"_blank\">Altavista</a>","scooter|mercator"),
										"northernlight"=>array("<a href=\"http://www.northernlight.com\" target=\"_blank\">Northernlight</a>","gulliver"),
										"disco"=>array("DISCo WatchMan","disco watchman"),
										"eule"=>array("<a href=\"http://www.eule.de\" target=\"_blank\">Eule</a>"),
										"fast"=>array("<a href=\"http://www.alltheweb.com\" target=\"_blank\">AllTheWeb</a>","fast"),
										"teoma"=>array("<a href=\"http://www.teoma.com\" target=\"_blank\">Teoma</a>"),
										"msn"=>array("<a href=\"http://search.msn.de\" target=\"_blank\">msn Suche</a>","msnbot"),
										"psbot"=>array("<a href=\"http://www.picsearch.com\" target=\"_blank\">Picsearch (psbot/0.1)</a>"),
										"tecomac"=>array("X-Crawler/Tecomac","tecomac-crawler"),
										"xaldon"=>array("Xaldon WebSpider","xaldon|webspider"),
										"wisenut"=>array("<a href=\"http://www.wisenut.com\" target=\"_blank\">Wisenut</a>","looksmart|wisenutbot")
									);

		$spider_info_array = array();
		$total_spider = 0;

		foreach ($spider_array AS $key => $value) {

			if ($value["1"]) {
				$exploded = explode("|", $value["1"]);
				$like_str = "browser LIKE '%".implode("%' OR browser LIKE '%",$exploded)."%'";
			} else {
				$like_str = "browser LIKE '%".$key."%'";
			}

			if ($key == "google") {
				$like_str .= " AND browser NOT LIKE '%googlebot%' AND browser NOT LIKE '%backrub%'";
			}

			$result = db_select("SELECT number FROM ".$sql."_stats_power WHERE ".$like_str);
			$num_spider = db_num_rows($result);

			$spider_info_array[$key] = $num_spider;
			$total_spider += $num_spider;

		}

		arsort($spider_info_array);

		$spider_max_array = $spider_info_array;
		rsort($spider_max_array);

		if ($spider_max_array["0"]) {

			$scale = ($this->statistic_max_2-20)/$spider_max_array["0"];

			tabletop($this->module_language["0941"]." (".$this->module_language["main"]["total"].": ".$total_spider.")");

			echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

			foreach ($spider_info_array AS $key => $value) {

				$width = $value*$scale;
				if ($totalpages) { $pro_data = ($value*100)/$total_spider; }

				$pro_data = @sprintf("%01.2lf", $pro_data);

				if ($width == ($this->statistic_max_2-20)) {
					$graphic = "poll_3.gif";
				} else {
					$graphic = "poll.gif";
				}

				echo "<tr><td width=\"120\">".$spider_array["$key"]["0"]."</td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\"><strong>$pro_data %</strong> (".$value.")</td></tr>";

			}

			echo "</table>";

			tablefooter();
			echo "<br />";

		}

		$this->get_referer("20", "1");

		form_moveon("$PHP_SELF?file=$file&mode=page_2");
		form_moveonsite("$PHP_SELF?file=$file&mode=page_4", $this->module_language["button"]["next"], "2");

	}

	/*
		class contentpapst_gui_statistic::do_page_4
	*/

	function do_page_4() {

		include("config.php");
		include_once("functions/cp.string.php");
		GLOBAL $sql, $file, $PHP_SELF;

		$result = db_select("SELECT number FROM ".$sql."_stats_power");
		$totalpages = db_num_rows($result);

		$i = 0;

		tabletop($this->module_language["0945"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

		$result = db_select("SELECT browser, COUNT(*) AS count FROM ".$sql."_stats_power GROUP by browser ORDER by count DESC LIMIT 0,30");
		while ($row = db_fetch_array($result,"assoc")) {

			$i++;

			if ($totalpages) {
				$pro_data = ($row["count"]*100)/$totalpages;
			}

			$pro_data = @sprintf("%01.2lf",$pro_data);

			echo "<tr><td width=\"25\">".$i."</td><td>".cp_string_shorten($row["browser"], 100)."</td><td align=\"right\" width=\"150\"><strong>".$pro_data." %</strong> (".$row["count"].")</td></tr>";

		}

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_moveon("$PHP_SELF?file=$file&mode=page_3");

	}

	/*
		class contentpapst_gui_statistic::do_search_words
	*/

	function do_search_words() {

		include_once("functions/cp.string.php");
		$this->get_referer("50");
		form_back("1");

	}

	/*
		class contentpapst_gui_statistic::do_graphic
	*/

	function do_graphic() {

		GLOBAL $file;
		include("modules/$file/graphic.php");
		statistic_graphic();

	}

	/*
		class contentpapst_gui_statistic::do_set_options
	*/

	function do_set_options($form) {

		GLOBAL $sql, $file, $PHP_SELF;

		$rights_array = array("lang", "referer", "count");

		foreach ($rights_array AS $key => $value) {
			if (!$form["$value"]) {
				$form["$value"] = "0";
			}
		}

		foreach($form AS $key => $value) {
			if (!$value) { $value = "0"; }
			db_update("UPDATE ".$sql."_options SET value = '".db_escape_string($value)."' WHERE title = '".db_escape_string($key)."' AND module = 'statistic'");
		}

		set_db_config();

		header("Location: $PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_statistic::get_referer
	*/

	function get_referer($max_results = "20", $show_more = "") {

		GLOBAL $file, $total_pages, $PHP_SELF, $themeadmin, $lang, $sql;

		$referer_array = array(
										"google"=>"q",
										"yahoo"=>"p",
										"hotbot.com"=>"query",
										"lycos"=>"query",
										"alltheweb.com"=>"q",
										"altavista.com"=>"q",
										"search.com"=>"q",
										"web.de"=>"su",
										"fireball.de"=>"q",
										"search.msn"=>"q",
										"suche.aol"=>"q",
										"suche.aol"=>"query",
										"freenet"=>"query"
									);

		if (!$total_pages) {
			$result = db_select("SELECT number FROM ".$sql."_stats_power");
			$totalpages = db_num_rows($result);
		}

		$referer_info_array = array();
		$referer_count = 0;

		foreach ($referer_array AS $key => $value) {

			$result = db_select("SELECT referer FROM ".$sql."_stats_power WHERE referer LIKE '%".$key."%'");
			while ($row = db_fetch_array($result,"assoc")) {

				$tmp_url = parse_url($row["referer"]);
				parse_str($tmp_url["query"]);
				$tmp_query = urldecode(rawurldecode($$value));

				if (cp_key_exists($referer_info_array, $tmp_query)) {
					$referer_info_array["$tmp_query"] += 1;
				} else {
					$referer_info_array["$tmp_query"] = 1;
				}

				$referer_count++;

			}
		}

		arsort($referer_info_array);

		$referer_max_array = $referer_info_array;
		rsort($referer_max_array);

		if ($referer_max_array["0"]) {

			$scale = ($this->statistic_max_2-20)/$referer_max_array["0"];

			if ($show_more) {
				$show_mode_string = ", <a href=\"$PHP_SELF?file=$file&mode=search_words\"><u>".$this->module_language["0756"]."</u></a>";
			} else {
				$show_mode_string = "";
			}

			tabletop($this->module_language["0942"]." (".$this->module_language["main"]["total"].": ".$referer_count.$show_mode_string.")");

			echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

			$loop_count = 0;

			foreach ($referer_info_array AS $key => $value) {

				$loop_count++;
				$key = utf8_decode($key);

				if ($loop_count > $max_results) {
					break;
				}

				$width = $value*$scale;
				if ($totalpages) { $pro_data = ($value*100)/$referer_count; }

				$pro_data = @sprintf("%01.2lf", $pro_data);

				if ($width == ($this->statistic_max_2-20)) {
					$graphic = "poll_3.gif";
				} else {
					$graphic = "poll.gif";
				}

				echo "<tr><td width=\"120\"><a href=\"http://www.google.com/search?q=".urlencode($key)."&hl=de\" title=\"".$key."\" target=\"_blank\">".cp_string_shorten($key, 22)."</a></td><td><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/><img src=\"themes/$themeadmin/images/$graphic\" border=\"0\" width=\"".round($width)."\" height=\"8\" alt=\"\"/><img src=\"themes/$themeadmin/images/poll_2.gif\" border=\"0\" alt=\"\"/></td><td align=\"right\"><strong>$pro_data %</strong> (".$value.")</td></tr>";

			}

			echo "</table>";

			tablefooter();
			echo "<br />";

		}

	}

}
?>